require "defines"
require "story"

gt = game.gettext
game.oninit(function()
  local character = game.player.character
  if character then character.destroy() end
  game.player.setcontroller{type=defines.controllers.god}
end)

-- The story contents
storytable =
{{
  {
    action = function() game.showmessagedialog(gt("msg-introduction")) end 
  },
  {
    action = function() game.showmessagedialog(gt("msg-ask-chest")) end
  },
  {
    action =
    function()
      game.player.gui.top.add{type = "button", name="button_use_chest", caption=gt("button-use-chest")}
      game.player.gui.top.add{type = "button", name="button_no_chest", caption=gt("button-no-chest")}
    end
  },
  {
    condition =
    function(event)
      if event.name == defines.events.onguiclick then
        if event.element.name == "button_use_chest" then
          buildstartingchest()
        end
        return true
      end
      return false
    end,
    action = function()
      game.player.gui.top.button_use_chest.destroy()
      game.player.gui.top.button_no_chest.destroy()
      game.showmessagedialog(gt("msg-ask-technologies"))
    end
  },
  {
    action =
    function()
      game.player.gui.top.add{type = "button", name="button_technologies_researched", caption=gt("button-technologies-researched")}
      game.player.gui.top.add{type = "button", name="button_technologies_normal", caption=gt("button-technologies-normal")}
    end
  },
  {
    condition =
    function(event)
      if event.name == defines.events.onguiclick then
        if event.element.name == "button_technologies_researched" then
          game.player.force.researchalltechnologies()
        end
        return true
      end
      return false
    end,
    action = function()
      game.player.gui.top.button_technologies_researched.destroy()
      game.player.gui.top.button_technologies_normal.destroy()
      action = function() game.showmessagedialog(gt("msg-start-play")) end
    end
  },
  -- start the game
  {
    action =
    function()
      game.onevent(defines.events, nil)
    end
  },
  {
    condition = function() return false end,
    action = function() end
  }
}}

mainstory = story.Story:new(storytable)

game.onsave(function()
  glob.storydata = mainstory:export()
end)

game.onload(function()
  mainstory:import(glob.storydata)
end)

game.onevent(defines.events, function(event)
  mainstory:update(event, "")
end)

function buildstartingchest()
  local chestposition = game.findnoncollidingposition("steel-chest", game.player.position, 0, 0.1)
  local chest = game.createentity{name="steel-chest", position=chestposition}
  chest.insert({name="wood", count="50"})
  chest.insert({name="coal", count="100"})
  chest.insert({name="stone", count="100"})
  chest.insert({name="iron-plate", count="400"})
  chest.insert({name="copper-plate", count="400"})
  chest.insert({name="steel-plate", count="100"})
  chest.insert({name="iron-gear-wheel", count="200"})
  chest.insert({name="electronic-circuit", count="200"})
  chest.insert({name="advanced-circuit", count="200"})
  chest.insert({name="offshore-pump", count="6"})
  chest.insert({name="pipe", count="12"})
  chest.insert({name="boiler", count="12"})
  chest.insert({name="basic-mining-drill", count="50"})
  chest.insert({name="steam-engine", count="6"})
  chest.insert({name="stone-furnace", count="50"})
  chest.insert({name="basic-transport-belt", count="100"})
  chest.insert({name="fast-transport-belt", count="50"})
  chest.insert({name="express-transport-belt", count="50"})
  chest.insert({name="basic-inserter", count="50"})
  chest.insert({name="fast-inserter", count="50"})
  chest.insert({name="long-handed-inserter", count="50"})
  chest.insert({name="smart-inserter", count="50"})
  chest.insert({name="small-electric-pole", count="25"})
  chest.insert({name="assembling-machine-1", count="25"})
  chest.insert({name="assembling-machine-2", count="25"})
  chest.insert({name="straight-rail", count="150"})
  chest.insert({name="curved-rail", count="50"})
  chest.insert({name="train-stop", count="6"})
  chest.insert({name="rail-signal", count="25"})
  chest.insert({name="diesel-locomotive", count="6"})
  chest.insert({name="cargo-wagon", count="12"})
end
